//+-----------------------------------------------------------------------------------+
//|                                                       HMA_rotational_hedge_EA.mq4 |
//+-----------------------------------------------------------------------------------+

extern double Lots=0.10;
extern bool Agresive=false;

extern int   HMA_period=21; 
extern int   HMA_method=3;                         // MODE_SMA 
extern int   HMA_price=0;                          // PRICE_CLOSE 

extern int   ATR_period=50;
extern int   ATR_bars=100;
extern int   Rotation=5;
extern int   TradeBar=0;
extern int   Slippage=3;
extern int   Magic_Number=654;
string com="hma ea";

double last_dir=0;
datetime last_t=0;

int init(){return(0);}
int deinit(){return(0);}
int start()
  {
   int i=0;
   double hma1=iCustom(Symbol(),0,"HMA",HMA_period,HMA_method,HMA_price,0,TradeBar);
   double hma2=iCustom(Symbol(),0,"HMA",HMA_period,HMA_method,HMA_price,1,TradeBar);
   double hma1_1=iCustom(Symbol(),0,"HMA",HMA_period,HMA_method,HMA_price,0,TradeBar+1);
   double hma2_1=iCustom(Symbol(),0,"HMA",HMA_period,HMA_method,HMA_price,1,TradeBar+1);

   if (TimeCurrent()<D'2004.06.04 15:00:00') return(0);
   
   Comment("");
   if (TotalOrders(Magic_Number)==1){
      tr(Magic_Number,NormalizeDouble((maxAtr(ATR_period,ATR_bars)*2)/Point,0));
      Comment("Trail at: "+(NormalizeDouble((maxAtr(ATR_period,ATR_bars)*2)/Point,0))+" pips");
      for (int j=0;j<OrdersTotal();j++){
         OrderSelect(j,SELECT_BY_POS);
         if (OrderMagicNumber()==Magic_Number) break;         
      }
      if (OrderProfit()>0 && OrderType()==OP_BUY && hma2!=EMPTY_VALUE && hma1==EMPTY_VALUE && hma1_1!=EMPTY_VALUE && hma2_1!=EMPTY_VALUE){
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),Slippage,Pink);
      }
      if (OrderProfit()>0 && OrderType()==OP_SELL && hma1!=EMPTY_VALUE && hma2==EMPTY_VALUE && hma1_1!=EMPTY_VALUE && hma2_1!=EMPTY_VALUE){
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),Slippage,Pink);
      }      
   }
      
   if (TotalOrders(Magic_Number)>1 && ProfitTotal(Magic_Number)>0 &&  Time[0]>last_t && 
      ((hma2!=EMPTY_VALUE && hma1==EMPTY_VALUE && hma1_1!=EMPTY_VALUE && hma2_1!=EMPTY_VALUE) || 
       (hma1!=EMPTY_VALUE && hma2==EMPTY_VALUE && hma1_1!=EMPTY_VALUE && hma2_1!=EMPTY_VALUE))      
      ){
      bool g=false;
      while (!g){
         g=true;
         for (j=0;j<OrdersTotal();j++){
            OrderSelect(j,SELECT_BY_POS);
            if (OrderMagicNumber()==Magic_Number && OrderType()==OP_BUY){
               RefreshRates();
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),Slippage,Pink);
               g=false;
               break;
            }
            if (OrderMagicNumber()==Magic_Number && OrderType()==OP_SELL){
               RefreshRates();
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),Slippage,Pink);
               g=false;
               break;
            }            
         }
      }
   }   
   

   
   if (Time[0]>last_t){
      if (hma1!=EMPTY_VALUE && hma2==EMPTY_VALUE && hma1_1!=EMPTY_VALUE && hma2_1!=EMPTY_VALUE && last_dir!=1){
         RefreshRates();
         if (OrderSend(Symbol(),OP_BUY,MM_Lots(Magic_Number,Lots,Agresive),NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),Slippage,0,0,com,Magic_Number,0,Blue)==-1) {
               i=GetLastError();
               if (i!=1 && i!=0) Print("Start Buy Error :"+error(i)+" at "+Symbol()+" "+Period());                 
         }         
         last_dir=1;
         last_t=Time[0];
         return(0);
      }
      if (hma2!=EMPTY_VALUE && hma1==EMPTY_VALUE && hma1_1!=EMPTY_VALUE && hma2_1!=EMPTY_VALUE && last_dir!=2){
         RefreshRates();
         if (OrderSend(Symbol(),OP_SELL,MM_Lots(Magic_Number,Lots,Agresive),NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),Slippage,0,0,com,Magic_Number,0,Red)==-1) {
               i=GetLastError();
               if (i!=1 && i!=0) Print("Start Sell Error :"+error(i)+" at "+Symbol()+" "+Period());                 
         }         
         last_dir=2;
         last_t=Time[0];
         return(0);
      }      
   }
   
   if (TotalOrders(Magic_Number)>Rotation){
      datetime t=EMPTY_VALUE;
      int t2=0;
      for (j=0;j<OrdersTotal();j++){
         OrderSelect(j,SELECT_BY_POS);
         if (OrderMagicNumber()==Magic_Number && OrderOpenTime()<t){
            t=OrderOpenTime();
            t2=OrderTicket();            
         }
      }
      if (t2!=0){
         OrderSelect(t2,SELECT_BY_TICKET);
         if (OrderType()==OP_BUY){
            RefreshRates();
            OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),Slippage,Pink);
         }
         if (OrderType()==OP_SELL){
            RefreshRates();
            OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),Slippage,Pink);
         }         
      }
   }

   return(0);
  }
double ProfitTotal(int m){
   double rez=0;
   for (int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS);
      if (OrderMagicNumber()==m) {
         rez=rez+OrderProfit()+OrderSwap();
      }
   }
   return(rez);
}

double MM_Lots(int m,double l,bool a){
   if (!a){
      if (TotalOrders(Magic_Number)<3) {return (NormalizeDouble(((TotalOrders(Magic_Number)+1)*l),1));}else{
         return(3*l);
      }
   }else{
      return (llot(m)+l);
   }
}
double llot(int m){
   double rez=0;
   for (int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS);
      if (OrderLots()>rez && OrderMagicNumber()==m) rez=OrderLots();
   }
   return(rez);
}
void tr(int magic,int triling_i){  
  for (int k=0;k<OrdersTotal();k++){
    OrderSelect(k,SELECT_BY_POS);
    if (OrderMagicNumber()==magic){        
      if (OrderType()==OP_BUY && NormalizeDouble(Ask-OrderOpenPrice(),Digits)>=triling_i*Point && OrderStopLoss()<NormalizeDouble(Ask-triling_i*Point,Digits)) {
         if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask-triling_i*Point,Digits),OrderTakeProfit(),0,Blue)){
            Print("Trailing stop error Buy :"+error(GetLastError()));
         }    
      }
      if (OrderType()==OP_SELL && NormalizeDouble(Bid+triling_i*Point,Digits)<=OrderOpenPrice() && (OrderStopLoss()>NormalizeDouble(Bid+triling_i*Point,Digits) || OrderStopLoss()==0)) {
         if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid+triling_i*Point,Digits),OrderTakeProfit(),0,Red)){
            Print("Trailing stop error Sell :"+error(GetLastError()));  
         }
      }
    }
  }
}

int TotalOrders(int magic){
   int rez=0;
   for (int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS);
      if (OrderMagicNumber()==magic){
         rez++;
      }
   }   
   return(rez);
} 

double maxAtr(int a,int bar){
   double max=0;
   for (int i=0;i<100;i++){
      double at=iATR(Symbol(),0,ATR_period,i);
      if (at>max) max=at;
   }
   return (max);
}

string error(int err){
switch (err){
 case 0 :return("No error returned.");
 case 1 :return("No error returned, but the result is unknown. ");
 case 2 :return("Common error. ");
 case 3 :return("Invalid trade parameters. ");
 case 4 :return("Trade server is busy. ");
 case 5 :return("Old version of the client terminal. ");
 case 6 :return("No connection with trade server. ");
 case 7 :return("Not enough rights. ");
 case 8 :return("Too frequent requests."); 
 case 9 :return("Malfunctional trade operation. ");
 case 64 :return("Account disabled. ");
 case 65 :return("Invalid account. ");
 case 128 :return("Trade timeout. ");
 case 129 :return("Invalid price. ");
 case 130 :return("Invalid stops. ");
 case 131 :return("Invalid trade volume. ");
 case 132 :return("Market is closed. ");
 case 133 :return("Trade is disabled. ");
 case 134 :return("Not enough money. ");
 case 135 :return("Price changed. ");
 case 136 :return("Off quotes. ");
 case 137 :return("Broker is busy."); 
 case 138 :return("Requote. ");
 case 139 :return("Order is locked. ");
 case 140 :return("Long positions only allowed. ");
 case 141 :return("Too many requests. ");
 case 145 :return("Modification denied because order too close to market. ");
 case 146 :return("Trade context is busy. ");
 case 147 :return("Expirations are denied by broker. ");
 case 148 :return("The amount of open and pending orders has reached the limit set by the broker. ");
 case 4000 :return("No error. ");
 case 4001 :return("Wrong function pointer. ");
 case 4002 :return("Array index is out of range. ");
 case 4003 :return("No memory for function call stack. ");
 case 4004 :return("Recursive stack overflow. ");
 case 4005 :return("Not enough stack for parameter. ");
 case 4006 :return("No memory for parameter string. ");
 case 4007 :return("No memory for temp string. ");
 case 4008 :return("Not initialized string. ");
 case 4009 :return("Not initialized string in array. ");
 case 4010 :return("No memory for array string. ");
 case 4011 :return("Too long string. ");
 case 4012 :return("Remainder from zero divide. ");
 case 4013 :return("Zero divide. ");
 case 4014 :return("Unknown command. ");
 case 4015 :return("Wrong jump (never generated error). ");
 case 4016 :return("Not initialized array. ");
 case 4017 :return("DLL calls are not allowed. ");
 case 4018 :return("Cannot load library. ");
 case 4019 :return("Cannot call function. ");
 case 4020 :return("Expert function calls are not allowed. ");
 case 4021 :return("Not enough memory for temp string returned from function. ");
 case 4022 :return("System is busy (never generated error). ");
 case 4050 :return("Invalid function parameters count. ");
 case 4051 :return("Invalid function parameter value. ");
 case 4052 :return("String function internal error. ");
 case 4053 :return("Some array error. ");
 case 4054 :return("Incorrect series array using. ");
 case 4055 :return("Custom indicator error. ");
 case 4056 :return("Arrays are incompatible. ");
 case 4057 :return("Global variables processing error. ");
 case 4058 :return("Global variable not found. ");
 case 4059 :return("Function is not allowed in testing mode. ");
 case 4060 :return("Function is not confirmed. ");
 case 4061 :return("Send mail error. ");
 case 4062 :return("String parameter expected. ");
 case 4063 :return("Integer parameter expected. ");
 case 4064 :return("Double parameter expected. ");
 case 4065 :return("Array as parameter expected. ");
 case 4066 :return("Requested history data in updating state. ");
 case 4067 :return("Some error in trading function. ");
 case 4099 :return("End of file. ");
 case 4100 :return("Some file error."); 
 case 4101 :return("Wrong file name. ");
 case 4102 :return("Too many opened files. ");
 case 4103 :return("Cannot open file. ");
 case 4104 :return("Incompatible access to a file. ");
 case 4105 :return("No order selected. ");
 case 4106 :return("Unknown symbol. ");
 case 4107 :return("Invalid price. ");
 case 4108 :return("Invalid ticket. ");
 case 4109 :return("Trade is not allowed. ");
 case 4110 :return("Longs are not allowed. ");
 case 4111 :return("Shorts are not allowed. ");
 case 4200 :return("Object exists already. ");
 case 4201 :return("Unknown object property. ");
 case 4202 :return("Object does not exist. ");
 case 4203 :return("Unknown object type. ");
 case 4204 :return("No object name. ");
 case 4205 :return("Object coordinates error. ");
 case 4206 :return("No specified subwindow. ");
 case 4207 :return("Some error in object function. ");
 default: return("Unknown error:"+err);
}
}